from wxPython.wx import *
from wxPython.grid import *
import parser
class MyFrame(wxFrame):
     	def __init__(self, *args, **kwds):
        	# begin wxGlade: MyFrame.__init__
        	kwds["style"] = wxDEFAULT_FRAME_STYLE
        	wxFrame.__init__(self, *args, **kwds)
        	self.grid_1 = wxGrid(self, -1, size=(1, 1))
		self.__set_properties()
        	self.__do_layout()
		
		
	def __set_properties(self):
        	# begin wxGlade: MyFrame.__set_properties
        	self.SetTitle("MeahAP Manager - Iptables Response")
     		self.SetSize(wxDLG_SZE(self, (390, 136)))
        	self.grid_1.CreateGrid(0,8)		
		#self.grid_1.EnableDragColSize(0)
        	self.grid_1.SetColLabelValue(0, "Chain")
        	self.grid_1.SetColLabelValue(1, "Policy")
        	self.grid_1.SetColLabelValue(2, "Num")
        	self.grid_1.SetColLabelValue(3, "Protocol")
        	self.grid_1.SetColLabelValue(4, "Option")
        	self.grid_1.SetColLabelValue(5, "Source")
        	self.grid_1.SetColLabelValue(6, "Destination")
        	self.grid_1.SetColLabelValue(7, "Target")
        	self.grid_1.SetMinSize(wxDLG_SZE(self.grid_1, (387, 150)))
		
		
	def __do_layout(self):
		# begin wxGlade: MyFrame.__do_layout
		sizer_1 = wxBoxSizer(wxVERTICAL)
		sizer_1.Add(self.grid_1, 1, wxEXPAND, 0)
		self.SetAutoLayout(True)
		self.SetSizer(sizer_1)
		self.Layout()

import wx
class ViewResponse(MyFrame):
	def __init__(self):
		self.app = wx.App(0)
		MyFrame.__init__(self, None, -1, "")
	def run(self,xmlresponse):
		# View = MainView( 
		# app.SetTopWindow(View)
		rows = self.grid_1.GetNumberRows()
		self.grid_1.DeleteRows(0,rows)			
		pars=parser.Parser(self)
		pars.run(xmlresponse)
		self.grid_1.AutoSize()
		self.grid_1.EnableEditing(False)
		self.grid_1.DisableDragRowSize()
		self.grid_1.DisableDragColSize()
		self.grid_1.SetRowLabelSize(0)
		
		row = self.grid_1.GetNumberRows()
		while row>=0:
			if self.grid_1.GetCellValue(row,0)!="FORWARD":
				for col in [0,1,2,3,4,5,6,7]:
					self.grid_1.SetCellBackgroundColour(row,col,'#efefef')
			row=row-1  
		self.CenterOnScreen()
		self.Show()
		self.app.MainLoop()

if __name__ == "__main__":
	xmltrial="<!DOCTYPE meshap-manager SYSTEM \"MeshAP.dtd\"><meshap-manager><iptables-response><listtable><table chain=\"INPUT\" policy=\"ACCEPT\"><rule num=\"1\" target=\"ACCEPT\" protocol=\"icmp\" option=\"--\" source=\"localhost.localdomain\" destination=\"anywhere\"/><rule num=\"2\" target=\"ACCEPT\" protocol=\"tcp\" option=\"--\" source=\"127.0.0.3\" destination=\"anywhere\"/><rule num=\"3\" target=\"ACCEPT\" protocol=\"udp\" option=\"--\" source=\"127.0.0.3\" destination=\"anywhere\"/></table><table chain=\"FORWARD\" policy=\"ACCEPT\"><rule num=\"1\" target=\"ACCEPT\" protocol=\"icmp\" option=\"--\" source=\"localhost.localdomain\" destination=\"anywhere\"/><rule num=\"2\" target=\"ACCEPT\" protocol=\"icmp\" option=\"--\" source=\"127.0.0.2\" destination=\"anywhere\"/><rule num=\"3\" target=\"ACCEPT\" protocol=\"icmp\" option=\"--\" source=\"127.0.0.3\" destination=\"anywhere\"/></table><table chain=\"OUTPUT\" policy=\"ACCEPT\"><rule num=\"1\" target=\"ACCEPT\" protocol=\"icmp\" option=\"--\" source=\"localhost.localdomain\" destination=\"anywhere\"/><rule num=\"2\" target=\"ACCEPT\" protocol=\"udp\" option=\"--\" source=\"127.0.0.3\" destination=\"anywhere\"/></table></listtable></iptables-response></meshap-manager>"
	resp=ViewResponse()
	resp.run(xmltrial)
	