
import sys, string
from xml.dom import minidom, Node
import Grid
class Parser:
	def __init__(self, grid):
        	self.grid = grid
		
	def walk(self,parent,level):
		for node in parent.childNodes:
			if node.nodeType==Node.ELEMENT_NODE:
				#print "\nElement: %s" %node.nodeName
				attrs=node.attributes
				#tableAttr=('chain','policy')
				ruleAttr=('num', 'protocol', 'option', 'source', 'destination','target')
				
				if node.nodeName=='rule':
					attrNode=parent.attributes.get('chain')
					chainValue=attrNode.nodeValue
					attrNode=parent.attributes.get('policy')
					policyValue=attrNode.nodeValue
					attrNode=attrs.get('num')
					numValue=attrNode.nodeValue
					attrNode=attrs.get('protocol')
					protocolValue=attrNode.nodeValue
					attrNode=attrs.get('option')
					optionValue=attrNode.nodeValue
					attrNode=attrs.get('source')
					sourceValue=attrNode.nodeValue
					attrNode=attrs.get('destination')
					destinationValue=attrNode.nodeValue
					attrNode=attrs.get('target')
					targetValue=attrNode.nodeValue
					
					self.createRow(chainValue,policyValue,numValue,protocolValue,optionValue,sourceValue,destinationValue,targetValue)
					
				self.walk(node, level+1)
	
	def run (self,xmlresponse):
		doc=minidom.parseString(xmlresponse)   #parse("iptResponse.xml")
		rootNode=doc.documentElement
		level=0
		self.walk(rootNode,level)
	
	def createRow (self,chainValue,policyValue,numValue,protocolValue,optionValue,sourceValue,destinationValue,targetValue):
		chain=chainValue
		policy=policyValue
		num=numValue
		protocol=protocolValue
		option=optionValue
		source=sourceValue
		destination=destinationValue
		target=targetValue
		self.grid.grid_1.AppendRows(1)
		row = self.grid.grid_1.GetNumberRows()-1
		self.grid.grid_1.SetRowLabelValue(row,"")
		self.grid.grid_1.SetCellValue(row,0,chain)
		self.grid.grid_1.SetCellValue(row,1,policy)
		self.grid.grid_1.SetCellValue(row,2,num)
		self.grid.grid_1.SetCellValue(row,3,protocol)
		self.grid.grid_1.SetCellValue(row,4,option)
		self.grid.grid_1.SetCellValue(row,5,source)
		self.grid.grid_1.SetCellValue(row,6,destination)
		self.grid.grid_1.SetCellValue(row,7,target)
		
if __name__=="__main__":
	parser=Parser()
	parser.run()
	


